#include <Nextion.h>
#include <OpenWire.h>
#include <Mitov.h>
#include <Mitov_FormattedSerial.h>
#include <Mitov_Display_Nextion.h>
#include <DallasTemperature.h>  // The MAX31850 DallasTemp library https://github.com/adafruit/MAX31850_DallasTemp needs to be installed trough the Arduino IDE for this Scetch to compile!
#include <Mitov_Maxim_OneWire_Thermometer.h>
#include <Mitov_Timing.h>
#include <Mitov_Math.h>
#include <Mitov_BinaryGenerators.h>



NexDSButton bt0 = NexDSButton(1, 4, "bt0");
NexDSButton bt1 = NexDSButton(1, 5, "bt1");
char buffer[100] = {0};

NexTouch *nex_listen_list[] = {
  &bt0,  // Button added
  &bt1,  //
  NULL  };


void bt0PopCallback(void *ptr)  // Release event for button bt0
{
  uint32_t number5 = 0;  // Create variable to store value we are going to get
  bt0.getValue(&number5);  // Read value of dual state button to know the state (0 or 1)

  if(number5 == 1){  // If dual state button is equal to 1 (meaning is ON)...
    digitalWrite(13, HIGH);  // Turn ON internal LED
  }else{  // Since the dual state button is OFF...
    digitalWrite(13, LOW);  // Turn OFF internal LED
  }
  }
  void bt1PopCallback(void *ptr)  // Release event for button bt1
{
  uint32_t number6 = 0;  // Create variable to store value we are going to get
  bt1.getValue(&number6);  // Read value of dual state button to know the state (0 or 1)

  if(number6 == 1){  // If dual state button is equal to 1 (meaning is ON)...
    digitalWrite(12, HIGH);  // Turn ON internal LED
  }else{  // Since the dual state button is OFF...
    digitalWrite(12, LOW);  // Turn OFF internal LED
  }
  }


// Arduino Board Declarations

namespace BoardDeclarations
{
Mitov::TypedSerialPort<Mitov::SerialPort<SERIAL_TYPE, Serial>, SERIAL_TYPE, Serial> SerialPort0;
Mitov::ArduinoDigitalInputChannel<3, false> ArduinoDigitalChannel_3( false );
} // BoardDeclarations

// Declarations



namespace Declarations
{
Mitov::DisplayNextion<Mitov::TypedSerialPort<Mitov::SerialPort<SERIAL_TYPE, Serial>, SERIAL_TYPE, Serial>, BoardDeclarations::SerialPort0> DisplayNextion1;
Mitov::DisplayNextionElementText TArduinoDisplayNextionElementText1( Declarations::DisplayNextion1, "t0", -1, 0 );
Mitov::DisplayNextionElementText TArduinoDisplayNextionElementText2( Declarations::DisplayNextion1, "t1", -1, 1 );
Mitov::DisplayNextionElementText TArduinoDisplayNextionElementText3( Declarations::DisplayNextion1, "t2", -1, 2 );
Mitov::DisplayNextionElementText TArduinoDisplayNextionElementText4( Declarations::DisplayNextion1, "t3", -1, 3 );
Mitov::DisplayNextionElementAnalogProgressBar TArduinoDisplayNextionElementAnalogProgressBar1( Declarations::DisplayNextion1, "j0", -1, 4 );
Mitov::DisplayNextionElementText TArduinoDisplayNextionElementText5( Declarations::DisplayNextion1, "t12", -1, 12 );
Mitov::DisplayNextionElementButton TArduinoDisplayNextionElementButton1( Declarations::DisplayNextion1, "b0", -1, -1 );
Mitov::DisplayNextionElementText TArduinoDisplayNextionElementText6( Declarations::DisplayNextion1, "t13", -1, 13 );
Mitov::OneWireThermometer Thermometer1( 2, 0, 0x28, 0xFF, 0x20, 0xCE, 0xA4, 0x16, 0x05, 0x8D );
Mitov::OneWireThermometer Thermometer2( -1, 1, 0x28, 0xFF, 0x74, 0xDA, 0xA2, 0x16, 0x04, 0xBE );
Mitov::OneWireThermometer Thermometer3( -1, 2, 0x28, 0xFF, 0xD6, 0xBD, 0xA4, 0x16, 0x04, 0xC9 );
Mitov::OneWireThermometer Thermometer4( -1, 3, 0x28, 0xFF, 0x03, 0xDC, 0xA2, 0x16, 0x04, 0x8B );
Mitov::ClockGenerator ClockGenerator1;
Mitov::CompareValue<String> CompareValue1 = Mitov::CompareValue<String>( String() );
Mitov::PulseGeneratorSimple PulseGenerator2;
} // Declarations

// Type Converters

namespace TypeConverters
{
Mitov::TypedConvert<float,String> Converter0;
Mitov::TypedConvert<float,String> Converter1;
Mitov::TypedConvert<float,String> Converter2;
Mitov::TypedConvert<float,String> Converter3;
Mitov::Convert_DigitalToText Converter4;
Mitov::Convert_DigitalToText Converter5;
} // TypeConverters

// Pin Call Declarations

namespace PinCalls
{
void PinCallerReceive1( void *_Data );
void PinCallerReceive2( void *_Data );
void PinCallerReceive3( void *_Data );
void PinCallerReceive4( void *_Data );
void PinCallerReceive5( void *_Data );
void PinCallerReceive6( void *_Data );
void PinCallerReceive7( void *_Data );
void PinCallerReceive8( void *_Data );
void PinCallerReceive9( void *_Data );
void PinCallerReceive10( void *_Data );
void PinCallerReceive11( void *_Data );
void PinCallerReceive12( void *_Data );
void PinCallerReceive13( void *_Data );
void PinCallerReceive14( void *_Data );
void PinCallerReceive15( void *_Data );
} // PinCalls

// Pin Call Implementations

namespace PinCalls
{
void PinCallerReceive1( void *_Data )
{
  Declarations::TArduinoDisplayNextionElementAnalogProgressBar1.InputPin_o_Receive( _Data );
  TypeConverters::Converter0.Convert( _Data, PinCallerReceive2 );
}

void PinCallerReceive2( void *_Data )
{
  Declarations::TArduinoDisplayNextionElementText1.InputPin_o_Receive( _Data );
  Declarations::CompareValue1.InputPin_o_Receive( _Data );
}
void PinCallerReceive3( void *_Data )
{
  Declarations::Thermometer1.OneWireInputPin_o_Receive( _Data );
}

void PinCallerReceive5( void *_Data )
{
  TypeConverters::Converter1.Convert( _Data, PinCallerReceive4 );
}

void PinCallerReceive4( void *_Data )
{
  Declarations::TArduinoDisplayNextionElementText2.InputPin_o_Receive( _Data );
}
void PinCallerReceive6( void *_Data )
{
  Declarations::Thermometer2.OneWireInputPin_o_Receive( _Data );
}

void PinCallerReceive8( void *_Data )
{
  TypeConverters::Converter2.Convert( _Data, PinCallerReceive7 );
}

void PinCallerReceive7( void *_Data )
{
  Declarations::TArduinoDisplayNextionElementText3.InputPin_o_Receive( _Data );
}
void PinCallerReceive9( void *_Data )
{
  Declarations::Thermometer3.OneWireInputPin_o_Receive( _Data );
}

void PinCallerReceive11( void *_Data )
{
  TypeConverters::Converter3.Convert( _Data, PinCallerReceive10 );
}

void PinCallerReceive10( void *_Data )
{
  Declarations::TArduinoDisplayNextionElementText4.InputPin_o_Receive( _Data );
}
void PinCallerReceive12( void *_Data )
{
  Declarations::Thermometer1.ClockInputPin_o_Receive( _Data );
}

void PinCallerReceive14( void *_Data )
{
  TypeConverters::Converter4.Convert( _Data, PinCallerReceive13 );
  TypeConverters::Converter5.Convert( _Data, PinCallerReceive15 );
  BoardDeclarations::ArduinoDigitalChannel_3.DigitalInputPin_o_Receive( _Data );
}

void PinCallerReceive13( void *_Data )
{
  Declarations::TArduinoDisplayNextionElementText5.InputPin_o_Receive( _Data );
}
void PinCallerReceive15( void *_Data )
{
  Declarations::TArduinoDisplayNextionElementText6.InputPin_o_Receive( _Data );
}
} // PinCalls

namespace ComponentsHardware
{
void SystemUpdateHardware()
{
}
} // ComponentsHardware


//The setup function is called once at startup of the sketch
void setup()
{
// pinMode(12, OUTPUT);  // Pin digital 12 como salida
// digitalWrite(12,LOW);
// pinMode(13, OUTPUT);  // Pin digital 13 como salida
 //digitalWrite(13,LOW);
  
  nexInit();

  // Register the event callback functions of each touch event:
  // You need to register press events and release events seperatly.
  // Format for press events: <object name>.attachPush(<object name>PushCallback);
  // Format for release events: <object name>.attachPop(<object name>PopCallback);
 
  bt0.attachPop(bt0PopCallback,&bt0);  // Button release
  bt1.attachPop(bt1PopCallback, &bt1);  // Button release
    
  Declarations::Thermometer1.AlarmHighTemperature = 90;
  Declarations::Thermometer1.OutputPin.SetCallback( PinCalls::PinCallerReceive1 );
  Declarations::Thermometer2.OneWireOutputPin.SetCallback( PinCalls::PinCallerReceive3 );
  Declarations::Thermometer2.OutputPin.SetCallback( PinCalls::PinCallerReceive5 );
  Declarations::Thermometer3.OneWireOutputPin.SetCallback( PinCalls::PinCallerReceive6 );
  Declarations::Thermometer3.OutputPin.SetCallback( PinCalls::PinCallerReceive8 );
  Declarations::Thermometer4.OneWireOutputPin.SetCallback( PinCalls::PinCallerReceive9 );
  Declarations::Thermometer4.OutputPin.SetCallback( PinCalls::PinCallerReceive11 );
  Declarations::ClockGenerator1.Frequency = 10;
  Declarations::ClockGenerator1.OutputPin.SetCallback( PinCalls::PinCallerReceive12 );
  Declarations::CompareValue1.OutputPin.SetCallback( PinCalls::PinCallerReceive14 );
  Declarations::CompareValue1.Value = "30";
  Declarations::CompareValue1.CompareType = Mitov::ctBigger;

  BoardDeclarations::SerialPort0.SystemInit();
  Declarations::DisplayNextion1.SystemInit();
  Declarations::Thermometer1.SystemInit();
  Declarations::Thermometer2.SystemInit();
  Declarations::Thermometer3.SystemInit();
  Declarations::Thermometer4.SystemInit();
  Declarations::ClockGenerator1.SystemInit();
  Declarations::PulseGenerator2.SystemInit();

  Declarations::Thermometer1.SystemStart();
  Declarations::Thermometer2.SystemStart();
  Declarations::Thermometer3.SystemStart();
  Declarations::Thermometer4.SystemStart();
  Declarations::ClockGenerator1.SystemStart();
  Declarations::CompareValue1.SystemStart();
  Declarations::PulseGenerator2.SystemStart();
}

// The loop function is called in an endless loop
void loop()
{
  unsigned long A_Current_Microseconds = micros();

  BoardDeclarations::SerialPort0.SystemLoopBegin( A_Current_Microseconds );
  Declarations::DisplayNextion1.SystemLoopBegin( A_Current_Microseconds );
  Declarations::Thermometer1.SystemLoopBegin( A_Current_Microseconds );
  Declarations::Thermometer2.SystemLoopBegin( A_Current_Microseconds );
  Declarations::Thermometer3.SystemLoopBegin( A_Current_Microseconds );
  Declarations::Thermometer4.SystemLoopBegin( A_Current_Microseconds );
  Declarations::ClockGenerator1.SystemLoopBegin( A_Current_Microseconds );
  Declarations::PulseGenerator2.SystemLoopBegin( A_Current_Microseconds );
  
// digitalWrite(12, HIGH);  // Turn ON internal LED
// delay (1000);
 //digitalWrite(12, LOW);  // Turn OFF internal LED
// delay (1000);
}
